/* DO NOT EDIT THIS FILE - it is machine generated */

/*
 * This file is part of libphidget22java
 *
 * Copyright 2015 Phidgets Inc <patrick@phidgets.com>
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 3 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, see
 * <http://www.gnu.org/licenses/>
 */

#include "phidget_jni.h"
#include "com_phidget22_Log.h"
#include "com_phidget22_LogBase.h"

jclass log_class;

void com_phidget22_LogBase_OnLoad(JNIEnv *env) {
	if (!(log_class = (*env)->FindClass(env, "com/phidget22/LogBase")))
		JNI_ABORT_STDERR("Couldn't FindClass com/phidget22/LogBase");
	if (!(log_class = (jclass)(*env)->NewGlobalRef(env, log_class)))
		JNI_ABORT_STDERR("Couldn't create NewGlobalRef log_class");
}

JNIEXPORT void JNICALL Java_com_phidget22_LogBase_disable(JNIEnv * env, jobject obj) {
	int error;
	if ((error = PhidgetLog_disable()))
		PH_THROW(error);
}

JNIEXPORT void JNICALL Java_com_phidget22_LogBase_enable(JNIEnv * env, jobject obj, jobject level, jstring destination) {
	int error;
	const char *destinationUTFChars = (destination == NULL ? NULL : (*env)->GetStringUTFChars(env, destination, NULL));
	if ((error = PhidgetLog_enable((Phidget_LogLevel)(*env)->CallIntMethod(env, level, LogLevel_getCode_mid), (const char *)destinationUTFChars)))
		PH_THROW(error);
	if (destinationUTFChars != NULL) (*env)->ReleaseStringUTFChars(env, destination, destinationUTFChars);
}

JNIEXPORT jobject JNICALL Java_com_phidget22_LogBase_getLevel(JNIEnv * env, jobject obj) {
	int error;
	Phidget_LogLevel level;
	if ((error = PhidgetLog_getLevel(&level)))
		PH_THROW(error);
	return (*env)->CallStaticObjectMethod(env, LogLevel_class, LogLevel_getEnum_mid, level);
}

JNIEXPORT void JNICALL Java_com_phidget22_LogBase_setLevel(JNIEnv * env, jobject obj, jobject level) {
	int error;
	if ((error = PhidgetLog_setLevel((Phidget_LogLevel)(*env)->CallIntMethod(env, level, LogLevel_getCode_mid))))
		PH_THROW(error);
}

JNIEXPORT void JNICALL Java_com_phidget22_LogBase_log__Lcom_phidget22_LogLevel_2Ljava_lang_String_2Ljava_lang_String_2(JNIEnv * env, jobject obj, jobject level, jstring source, jstring str) {
	int error;
	const char *sourceUTFChars = (source == NULL ? NULL : (*env)->GetStringUTFChars(env, source, NULL));
	const char *strUTFChars = (str == NULL ? NULL : (*env)->GetStringUTFChars(env, str, NULL));
	if ((error = PhidgetLog_loges((Phidget_LogLevel)(*env)->CallIntMethod(env, level, LogLevel_getCode_mid), (const char *)sourceUTFChars, (const char *)strUTFChars)))
		PH_THROW(error);
	if (sourceUTFChars != NULL) (*env)->ReleaseStringUTFChars(env, source, sourceUTFChars);
	if (strUTFChars != NULL) (*env)->ReleaseStringUTFChars(env, str, strUTFChars);
}

JNIEXPORT void JNICALL Java_com_phidget22_LogBase_log__Lcom_phidget22_LogLevel_2Ljava_lang_String_2(JNIEnv * env, jobject obj, jobject level, jstring str) {
	int error;
	const char *strUTFChars = (str == NULL ? NULL : (*env)->GetStringUTFChars(env, str, NULL));
	if ((error = PhidgetLog_logs((Phidget_LogLevel)(*env)->CallIntMethod(env, level, LogLevel_getCode_mid), (const char *)strUTFChars)))
		PH_THROW(error);
	if (strUTFChars != NULL) (*env)->ReleaseStringUTFChars(env, str, strUTFChars);
}

JNIEXPORT void JNICALL Java_com_phidget22_LogBase_rotate(JNIEnv * env, jobject obj) {
	int error;
	if ((error = PhidgetLog_rotate()))
		PH_THROW(error);
}

JNIEXPORT jboolean JNICALL Java_com_phidget22_LogBase_isRotating(JNIEnv * env, jobject obj) {
	int error;
	int isrotating;
	if ((error = PhidgetLog_isRotating(&isrotating)))
		PH_THROW(error);
	return isrotating;
}

JNIEXPORT void JNICALL Java_com_phidget22_LogBase_setRotating(JNIEnv * env, jobject obj, jlong size, jint keepCount) {
	int error;
	if ((error = PhidgetLog_setRotating((uint64_t)size, (int)keepCount)))
		PH_THROW(error);
}

JNIEXPORT void JNICALL Java_com_phidget22_LogBase_enableRotating(JNIEnv * env, jobject obj) {
	int error;
	if ((error = PhidgetLog_enableRotating()))
		PH_THROW(error);
}

JNIEXPORT void JNICALL Java_com_phidget22_LogBase_disableRotating(JNIEnv * env, jobject obj) {
	int error;
	if ((error = PhidgetLog_disableRotating()))
		PH_THROW(error);
}

JNIEXPORT void JNICALL Java_com_phidget22_LogBase_addSource(JNIEnv * env, jobject obj, jstring source, jobject level) {
	int error;
	const char *sourceUTFChars = (source == NULL ? NULL : (*env)->GetStringUTFChars(env, source, NULL));
	if ((error = PhidgetLog_addSource((const char *)sourceUTFChars, (Phidget_LogLevel)(*env)->CallIntMethod(env, level, LogLevel_getCode_mid))))
		PH_THROW(error);
	if (sourceUTFChars != NULL) (*env)->ReleaseStringUTFChars(env, source, sourceUTFChars);
}

JNIEXPORT jobject JNICALL Java_com_phidget22_LogBase_getSourceLevel(JNIEnv * env, jobject obj, jstring source) {
	int error;
	const char *sourceUTFChars = (source == NULL ? NULL : (*env)->GetStringUTFChars(env, source, NULL));
	Phidget_LogLevel level;
	if ((error = PhidgetLog_getSourceLevel((const char *)sourceUTFChars, &level)))
		PH_THROW(error);
	if (sourceUTFChars != NULL) (*env)->ReleaseStringUTFChars(env, source, sourceUTFChars);
	return (*env)->CallStaticObjectMethod(env, LogLevel_class, LogLevel_getEnum_mid, level);
}

JNIEXPORT void JNICALL Java_com_phidget22_LogBase_setSourceLevel(JNIEnv * env, jobject obj, jstring source, jobject level) {
	int error;
	const char *sourceUTFChars = (source == NULL ? NULL : (*env)->GetStringUTFChars(env, source, NULL));
	if ((error = PhidgetLog_setSourceLevel((const char *)sourceUTFChars, (Phidget_LogLevel)(*env)->CallIntMethod(env, level, LogLevel_getCode_mid))))
		PH_THROW(error);
	if (sourceUTFChars != NULL) (*env)->ReleaseStringUTFChars(env, source, sourceUTFChars);
}
